﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "ABMPageTemplate"  '<---------------------------------- IMPORTANT
	' will hold the unique browsers window id
	Private ABMPageId As String = ""

	' your own variables
	Private gen As ABMGenerator  ' required to build the CRUD code.
	Private genname As String = "USER.txt"
	Dim ActiveUSERUserID As Int
	Dim IsNewUSER As Boolean
	Dim FilterUSER As String
	Dim LastSortUSER As String
	

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub


Private Sub WebSocket_Connected (WebSocket1 As WebSocket)	
	Log("Connected")
		
	ws = WebSocket1		
	
	ABMPageId = ABM.GetPageID(page, Name,ws)
	
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
	'----------------------START MODIFICATION 4.00-------------------------------
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If
	'----------------------END MODIFICATION 4.00-------------------------------
	
	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, ABMPageId, "../")
			Return
		End If
	End If		
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)		
	If page.ComesFromPageCache Then
    	' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
		Log("Comes from cache")		
    	page.Refresh		
    	page.FinishedLoading		
	Else
    	If page.WebsocketReconnected Then
			Log("Websocket reconnected")
        	' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have any on the server. So we need to reload the page.
        	' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has content, reconnected but we have no content in cache
        	ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
    	Else
        	' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic content in the browser ... we are going to serve the dynamic content...
        	Log("Websocket first connection")
			page.Prepare
			ConnectPage			
    	End If
	End If
	Log(ABMPageId)		
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	
	If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
		Return
	End If
	Dim caller As Object = page.GetEventHandler(Me, eventName)
	If caller = Me Then
		If SubExists(Me, eventName) Then
			Params.Remove("eventname")
			Params.Remove("eventparams")
			' BEGIN NEW DRAGDROP
			If eventName = "page_dropped" Then
				page.ProcessDroppedEvent(Params)
			End If
			' END NEW DRAGDROP
			Select Case Params.Size
				Case 0
					CallSub(Me, eventName)
				Case 1
					CallSub2(Me, eventName, Params.Get(eventParams(0)))
				Case 2
					If Params.get(eventParams(0)) = "abmistable" Then
						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
						CallSub2(Me, eventName, PassedTables)
					Else
						CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
					End If
				Case Else
					' cannot be called directly, to many param
					CallSub2(Me, eventName, Params)
			End Select
		End If
	Else
		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
	End If
End Sub


public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = "Template"
	page.PageDescription = "Template"
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	page.ShowConnectedIndicator = True
				
	' adding a navigation bar
	ABMShared.BuildNavigationBar(page, "Title","../images/logo.png", "", "", "")	
			
	' minimum page grid needed
	page.AddRowsM(1,True,0,0, "").AddCells12(1,"")
	page.AddRows(1,True, "").AddCellsOS(1,0,0,0,10,10,11,"").AddCellsOSMP(1,0,0,0,2,2,1,14,0,0,0,"")
	page.AddRows(2,True, "").AddCells12(1,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
		
End Sub

public Sub ConnectPage()			
	'	connecting the navigation bar
	ABMShared.ConnectNavigationBar(page)

	page.AddModalSheetTemplate(ABMGenBuildUSER)
	page.AddModalSheetTemplate(ABMGenBuildUSERDelete)
	page.AddModalSheetTemplate(ABMGenBuildUSERBadInput)

	Dim ABMGenSearchUSER As ABMInput
	ABMGenSearchUSER.Initialize(page, "ABMGenSearchUSER", ABM.INPUT_TEXT, "Search user", False, "")
	page.CellR(1,1).AddComponent(ABMGenSearchUSER)
	
	Dim ABMGenSearchBtnUSER As ABMButton
	ABMGenSearchBtnUSER.InitializeFloating(page, "ABMGenSearchBtnUSER", "mdi-action-search", "")
	page.CellR(0,2).AddComponent(ABMGenSearchBtnUSER)
	
	Dim ABMGenPaginationUSER As ABMPagination
	ABMGenPaginationUSER.Initialize(page, "ABMGenPaginationUSER", 10, True, True, "")
	ABMGenPaginationUSER.SetTotalNumberOfPages(0)
	page.CellR(1,1).AddComponent(ABMGenPaginationUSER)
	
	' create the ABMGenTableUSER table
	Dim ABMGenTableUSER As ABMTable
	' IMPORTANT: we set usingQueriesToSort = true because we are going to handle the sorting, not the javascript sorting library
	' When using Pagination, the sorting library does not know all the data
	' SetColumnDataFields() is used when the user clicks on a column head to sort to return in the SortChanged() event and the GetSortColumn() And SetSortColumn() methods.
	ABMGenTableUSER.Initialize(page, "ABMGenTableUSER", True, True, True, "tbltheme")
	ABMGenTableUSER.SetHeaders(         Array As String (""      ,"User Name","Login Name","Password"    ,"User Type","Active"    ,"Picture","Open/Edit","Delete"))

'   this line was replaced to use themes we added
'	ABMGenTableUSER.SetHeaderThemes(    Array As String (""      ,""         ,""          ,""            ,""         ,""          ,""       ,""         ,""      ))
	ABMGenTableUSER.SetHeaderThemes(    Array As String ("bgc"   , "bgc"     , "bgc"      , "bgc"        ,  "bgc"    ,  "bgc"     ,  "bgc"  ,   "bgc"   ,  "bgc" ))
	
	ABMGenTableUSER.SetHeaderHeights(   Array As Int    (0       ,0          ,0           ,0             ,0          ,0           ,0        ,0          ,0       ))
	ABMGenTableUSER.SetColumnWidths(    Array As Int    (0       ,0          ,0           ,0             ,0          ,0           ,0        ,70         ,70      ))
	ABMGenTableUSER.SetColumnVisible(   Array As Boolean(False   ,True       ,True        ,True          ,True       ,True        ,False     ,True       ,True    ))
	ABMGenTableUSER.SetColumnSortable(  Array As Boolean(False   ,True       ,True        ,True          ,True       ,True        ,False     ,False      ,False   ))
	ABMGenTableUSER.SetColumnDataFields(Array As String ("UserID","UserName" ,"UserLogin" ,"UserPassword","UserType" ,"UserActive","pic"    ,""         ,""      ))
	ABMGenTableUSER.SetFooter("Number of rows", 12, "bg")
	ABMGenTableUSER.IsBordered = True

	page.CellR(1,1).AddComponent(ABMGenTableUSER)

	' create the add USER action button
	Dim ABMGenTableAddUSER As ABMActionButton
	ABMGenTableAddUSER.Initialize(page, "ABMGenTableAddUSER", "mdi-content-add", "", "")
	ABMGenTableAddUSER.MainButton.Size = ABM.BUTTONSIZE_LARGE
	
	' add to page
	page.AddActionButton(ABMGenTableAddUSER)

	' IMPORTANT: If you added the above code to BuildPage you have to put this line as the last in Websocket_Connected()
	LoadABMGenTableUSER(1)
	' 			 If you added the above code to ConnectPage you have to put these lines as the last in ConnectPage()
	page.Refresh ' IMPORTANT
	
	' NEW, because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
	page.FinishedLoading 'IMPORTANT
	
	page.RestoreNavigationBarPosition


	' this was used (BuildCrudCode) to generate the code used in this example
	' look at this method to see what was required...

	'	BuildCrudCode
	
End Sub


' event for messdage boxes.  Do required methods based on user response
Sub page_MsgboxResult(returnName As String, result As String)

	If result = ABM.MSGBOX_RESULT_OK Then   '  the ok button was clicked...
		Log(" OK was pressed   Return name "&returnName&"  result: "&result)
	End If

	Select Case returnName
		Case "DELUSER"     
			Select Case result
				Case  "abmok" '  ABM.INPUTBOX_RESULT_CANCEL, ABM.INPUTBOX_RESULT_CLOSE, ABM.INPUTBOX_RESULT_ESC, ABM.INPUTBOX_RESULT_OVERLAY, ABM.INPUTBOX_RESULT_INVALID
				  Log(" Delete user... ")
				  ABMGenUSERDeleteYes_Clicked("")
		    End Select
	 End Select
	
End Sub



#Region ABMGenTableUSER table
Private Sub LoadABMGenTableUSER(fromPage As Int)
	Dim ABMGenTableUSER As ABMTable = page.Component("ABMGenTableUSER")   ' get the ABMtable to populate

	Dim SQL As SQL = DBM.GetSQL
	'  get the total number of records found
	Dim numFound As Int = DBM.ABMGenSQLSelectSingleResult(SQL, "SELECT Count(UserID) as IDS FROM users " & FilterUSER, Null)
	'  get the fields used to populate the ABMtable
	Dim results As List = DBM.ABMGenSQLSelect(SQL, "SELECT UserID, UserName, UserLogin, UserPassword, UserType, UserActive, pic FROM users " & FilterUSER & " " & LastSortUSER & " LIMIT " & ((fromPage - 1) * 5) & ", 5", Null)
	If results.Size = 0 And fromPage > 1 Then
		' we are on a page without any lines (maybe removed by other user?)
		DBM.CloseSQL(SQL)
		fromPage = fromPage - 1
		LoadABMGenTableUSER(fromPage)
		Return
	End If
	' You could for example set here the number of rows found
	ABMGenTableUSER.SetFooter("Total number of rows: " & numFound, 12,"bg")
	ABMGenTableUSER.Clear  ' clear the table for each new run

	For i = 0 To results.Size - 1
		Dim tblFields As Map = results.Get(i)
		Dim rCellValues As List
		Dim rCellThemes As List
		rCellValues.Initialize
		rCellThemes.Initialize

		rCellValues.Add(tblFields.Get("userid"))
		rCellThemes.Add("")

		rCellValues.Add(tblFields.Get("username"))
		rCellThemes.Add("nocolor")  ' nocolor theme used to center content in cell

		rCellValues.Add(tblFields.Get("userlogin"))
		rCellThemes.Add("nocolor")

		rCellValues.Add(tblFields.Get("userpassword"))
		rCellThemes.Add("nocolor")

	' the following lines were created by the generator - we shall change them
'		rCellValues.Add(tblFields.Get("usertype"))
'		rCellThemes.Add("")
'
'		rCellValues.Add(tblFields.Get("useractive"))
'		rCellThemes.Add("")

		'  here, we modify to show what we want
		'  *******************************************************************************
		'  *******************************************************************************
		Dim usrtype As Int = tblFields.Get("usertype")
		Select usrtype
			Case 0
				rCellValues.Add(("Basic"))
			Case 1
				rCellValues.Add(("Admin"))
			Case 2
				rCellValues.Add(("Super"))
		End Select
		rCellThemes.Add("nocolor")

		Dim cb As ABMCheckbox
		cb.Initialize(page,"cb"&i,"",False,"")
		cb.State = tblFields.Get("useractive") = "1"
		cb.Enabled = False
		cb.IsFilled = False
		rCellValues.Add(cb)
		rCellThemes.Add("nocolor")

		'  END of New stuff **************************************************************
		'  *******************************************************************************

		rCellValues.Add(tblFields.Get("pic"))
		rCellThemes.Add("")

		Dim ABMGenTableEditUSER As ABMButton
		ABMGenTableEditUSER.InitializeFloating(page, "ABMGenTableEditUSER", "mdi-action-visibility", "btngreen")
		rCellValues.Add(ABMGenTableEditUSER)
		rCellThemes.Add("nocolor")

		Dim ABMGenTableDeleteUSER As ABMButton
		ABMGenTableDeleteUSER.InitializeFloating(page, "ABMGenTableDeleteUSER", "mdi-action-delete", "btnred")
		rCellValues.Add(ABMGenTableDeleteUSER)
		rCellThemes.Add("nocolor")

		ABMGenTableUSER.AddRow("uidUSER" & i, rCellValues)
		ABMGenTableUSER.SetRowThemes(rCellThemes) ' make sure you have as many items in rCellThemes as in rCellValues!  Must follow IMMEDIATELY AFTER AddRow!
	Next
	ABMGenTableUSER.Refresh

	DBM.CloseSQL(SQL)

	Dim ABMGenPaginationUSER As ABMPagination = page.Component("ABMGenPaginationUSER")
	If (numFound Mod 5 > 0) Or (numFound = 0) Then
		numFound = numFound/5 + 1
	Else
		numFound = numFound/5
	End If
	ABMGenPaginationUSER.SetTotalNumberOfPages(numFound)
	ABMGenPaginationUSER.SetActivePage(fromPage)
	ABMGenPaginationUSER.Refresh

End Sub

Sub ABMGenPaginationUSER_PageChanged(OldPage As Int, NewPage As Int)
	' do your stuff
	LoadABMGenTableUSER(NewPage)
End Sub

Sub ABMGenTableAddUSER_Clicked(Target As String, SubTarget As String)
	' reset all the values on the form
	ActiveUSERUserID = 0
	ABMGenUSERNew
End Sub

Sub ABMGenTableUSER_Clicked(PassedRowsAndColumns As List)
	' fill with the active values
	Dim tblCellInfo As ABMTableCell = PassedRowsAndColumns.Get(0)
	Dim ABMGenTableUSER As ABMTable = page.Component(tblCellInfo.TableName)
	If tblCellInfo.Column = 7 Then ' edit
		ActiveUSERUserID = ABMGenTableUSER.GetString(tblCellInfo.row, 0)
		ABMGenUSEREdit(ActiveUSERUserID)
	End If
	If tblCellInfo.Column = 8 Then ' delete
		ActiveUSERUserID = ABMGenTableUSER.GetString(tblCellInfo.row, 0)   'set the primary key for user to delete
		' created by code gen - changed
'		ABMGenUSERDelete(ActiveUSERUserID)
		
' we shall use msgbox2		
		Dim usrname As String = ABMGenTableUSER.GetString(tblCellInfo.row, 1)   'get the user name
		page.Msgbox2( "DELUSER","Delete this user...","Delete "&usrname&" ?", "Delete","Cancel",False,ABM.MSGBOX_TYPE_QUESTION,False,ABM.MSGBOX_POS_CENTER_CENTER,"")
		' this will raise the page_MsgboxResult event where selection will be dealt with using returnname - "DELUSER"
	End If
End Sub

Sub ABMGenTableUSER_SortChanged(DataField As String, Order As String)
	Select Case DataField
		Case "UserName","UserLogin","UserPassword","UserType","UserActive","pic"
			LastSortUSER = " ORDER BY " & DataField & " " & Order & " "
		Case Else
			LastSortUSER = ""
	End Select
	' reload the table
	Dim ABMGenPaginationUSER As ABMPagination = page.Component("ABMGenPaginationUSER")
	LoadABMGenTableUSER(ABMGenPaginationUSER.GetActivePage())
End Sub

Sub ABMGenSearchBtnUSER_Clicked(Target As String)
	DoSearchUSER
End Sub

Sub ABMGenSearchUSER_EnterPressed(value As String)
	DoSearchUSER
End Sub

Sub DoSearchUSER()
	Dim ABMGenSearchUSER As ABMInput = page.Component("ABMGenSearchUSER")
	FilterUSER = ABMGenSearchUSER.Text
	If FilterUSER <> "" Then
		FilterUSER = " WHERE (UserName LIKE '%" & FilterUSER & "%'  OR UserLogin LIKE '%" & FilterUSER & "%'  OR UserPassword LIKE '%" & FilterUSER & "%'  OR UserType LIKE '%" & FilterUSER & "%'  OR UserActive LIKE '%" & FilterUSER & "%'  OR pic LIKE '%" & FilterUSER & "%' ) "
	Else
		FilterUSER = ""
	End If
	' reload the table
	LoadABMGenTableUSER(1)
End Sub
#End Region

#Region USER
Sub ABMGenBuildUSER() As ABMModalSheet
	Dim ABMGenUSERModal As ABMModalSheet
	ABMGenUSERModal.Initialize(page, "USER", True,  False, "")
	ABMGenUSERModal.IsDismissible = False


'  This is the code generated by the builder
'  We shall modify this to make it look the way we want

'	ABMGenUSERModal.Size = ABM.MODALSHEET_SIZE_LARGE
'	ABMGenUSERModal.Content.AddRowsM(1, True, 0, 0, "").AddCells12(1, "")
'	ABMGenUSERModal.Content.AddRowsM(2, True, 0, 0, "").AddCellsOS(1, 0, 0, 0, 4, 4, 4, "").AddCellsOS(1, 0, 0, 0, 4, 4, 4, "").AddCellsOS(1, 0, 0, 0, 4, 4, 4, "")
'	ABMGenUSERModal.Content.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
'
'	Dim ABMGenUSERTitleMessage As ABMLabel
'	ABMGenUSERTitleMessage.Initialize(page, "ABMGenUSERTitleMessage", "Enter all fields for this user" , ABM.SIZE_PARAGRAPH, False, "")
'	ABMGenUSERTitleMessage.IsBlockQuote = True
'	ABMGenUSERModal.Content.CellR(0,1).AddComponent(ABMGenUSERTitleMessage)
'
'	Dim ABMGenUSERUserName As ABMInput
'	ABMGenUSERUserName.Initialize(page, "ABMGenUSERUserName", ABM.INPUT_TEXT, "User Name", False, "")
'	ABMGenUSERModal.Content.CellR(1,1).AddComponent(ABMGenUSERUserName)
'	ABMGenUSERUserName.Text = ""
'
'	Dim ABMGenUSERUserLogin As ABMInput
'	ABMGenUSERUserLogin.Initialize(page, "ABMGenUSERUserLogin", ABM.INPUT_TEXT, "Login Name", False, "")
'	ABMGenUSERModal.Content.CellR(0,2).AddComponent(ABMGenUSERUserLogin)
'	ABMGenUSERUserLogin.Text = ""
'
'	Dim ABMGenUSERUserPassword As ABMInput
'	ABMGenUSERUserPassword.Initialize(page, "ABMGenUSERUserPassword", ABM.INPUT_TEXT, "Password", False, "")
'	ABMGenUSERModal.Content.CellR(0,3).AddComponent(ABMGenUSERUserPassword)
'	ABMGenUSERUserPassword.Text = ""
'
'	Dim ABMGenUSERUserType As ABMInput
'	ABMGenUSERUserType.Initialize(page, "ABMGenUSERUserType", ABM.INPUT_TEXT, "User Type", False, "")
'	ABMGenUSERModal.Content.CellR(1,1).AddComponent(ABMGenUSERUserType)
'	ABMGenUSERUserType.Text = "0"
'
'	Dim ABMGenUSERUserActive As ABMCheckbox
'	ABMGenUSERUserActive.Initialize(page, "ABMGenUSERUserActive", "Active", True, "")
'	ABMGenUSERModal.Content.CellR(0,2).AddComponent(ABMGenUSERUserActive)
'	ABMGenUSERUserActive.State = True
'
'	Dim ABMGenUSERpic As ABMInput
'	ABMGenUSERpic.Initialize(page, "ABMGenUSERpic", ABM.INPUT_TEXT, "Picture", False, "")
'	ABMGenUSERModal.Content.CellR(0,3).AddComponent(ABMGenUSERpic)
'	ABMGenUSERpic.Text = ""

	ABMGenUSERModal.Size = ABM.MODALSHEET_SIZE_NORMAL
	ABMGenUSERModal.Content.AddRowsM(2, True,  20, 0, "").AddCells12(1, "")
	ABMGenUSERModal.Content.AddRowsM(2, True, 20, 0, "").AddCellsOS(2, 0, 0, 0, 6, 6, 6, "") '.AddCellsOS(1, 0, 0, 0, 4, 4, 4, "").AddCellsOS(1, 0, 0, 0, 4, 4, 4, "")
	ABMGenUSERModal.Content.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components

	Dim ABMGenUSERTitleMessage As ABMLabel
	ABMGenUSERTitleMessage.Initialize(page, "ABMGenUSERTitleMessage", "Enter all fields for this user" , ABM.SIZE_H4, False, "")
	ABMGenUSERTitleMessage.IsBlockQuote = True
	ABMGenUSERModal.Content.CellR(0,1).AddComponent(ABMGenUSERTitleMessage)

	Dim ABMGenUSERUserName As ABMInput
	ABMGenUSERUserName.Initialize(page, "ABMGenUSERUserName", ABM.INPUT_TEXT, "User Name", False, "")
	ABMGenUSERModal.Content.CellR(1,1).AddComponent(ABMGenUSERUserName)
	ABMGenUSERUserName.Text = ""

	Dim ABMGenUSERUserLogin As ABMInput
	ABMGenUSERUserLogin.Initialize(page, "ABMGenUSERUserLogin", ABM.INPUT_TEXT, "Login Name", False, "")
	ABMGenUSERModal.Content.CellR(1,1).AddComponent(ABMGenUSERUserLogin)
	ABMGenUSERUserLogin.Text = ""

	Dim ABMGenUSERUserPassword As ABMInput
	ABMGenUSERUserPassword.Initialize(page, "ABMGenUSERUserPassword", ABM.INPUT_TEXT, "Password", False, "")
	ABMGenUSERModal.Content.CellR(0,2).AddComponent(ABMGenUSERUserPassword)
	ABMGenUSERUserPassword.Text = ""

	Dim ABMGenUSERUserType As ABMCombo

	ABMGenUSERUserType.Initialize(page, "ABMGenUSERUserType", "User Type", 300, "")
	
	ABMGenUSERUserType.AddItem(""&0, "Basic", BuildSimpleItem("S1", "mdi-action-account-circle", "{NBSP}{NBSP}Basic"))
	ABMGenUSERUserType.AddItem(""&1, "Admin", BuildSimpleItem("S2", "mdi-action-account-circle", "{NBSP}{NBSP}Admin"))
	ABMGenUSERUserType.AddItem(""&2, "Super", BuildSimpleItem("S3", "mdi-action-dashboard", "{NBSP}{NBSP}Super"))
	ABMGenUSERModal.Content.CellR(1,1).AddComponent(ABMGenUSERUserType)
'	ABMGenUSERUserType.SetActiveItemId("0")


	Dim ABMGenUSERUserActive As ABMCheckbox
	ABMGenUSERUserActive.Initialize(page, "ABMGenUSERUserActive", "Active", True, "")
	ABMGenUSERModal.Content.CellR(0,2).AddComponent(ABMGenUSERUserActive)
	ABMGenUSERUserActive.State = True

'	Dim ABMGenUSERpic As ABMInput
'	ABMGenUSERpic.Initialize(page, "ABMGenUSERpic", ABM.INPUT_TEXT, "Picture", False, "")
	' don't add this to the form....
'	ABMGenUSERModal.Content.CellR(0,3).AddComponent(ABMGenUSERpic)
'	ABMGenUSERpic.Text = ""




	ABMGenUSERModal.Footer.AddRowsM(1,True,0,0, "").AddCells12(1,"")
	ABMGenUSERModal.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components

	' create the buttons for the footer, create in opposite order as aligned right in a footer
	Dim ABMGenUSERCancel As ABMButton
	ABMGenUSERCancel.InitializeFlat(page, "ABMGenUSERCancel", "", "", "Cancel", "transparent")
	ABMGenUSERModal.Footer.Cell(1,1).AddComponent(ABMGenUSERCancel)
	
	Dim ABMGenUSERSave As ABMButton
	ABMGenUSERSave.InitializeFlat(page, "ABMGenUSERSave", "", "", "Save", "transparent")
	ABMGenUSERModal.Footer.Cell(1,1).AddComponent(ABMGenUSERSave)

	Return ABMGenUSERModal
End Sub

Sub BuildSimpleItem(id As String, icon As String, Title As String) As ABMLabel
	Dim lbl As ABMLabel
	If icon <> "" Then
		lbl.Initialize(page, id, Title, ABM.SIZE_H6, True, "header")
	Else
		lbl.Initialize(page, id, Title, ABM.SIZE_H6, True, "")
	End If
	lbl.VerticalAlign = True
	lbl.IconName = icon
	Return lbl
End Sub



' method you can call when the user wants to add a new record
Sub ABMGenUSERNew()
	Dim ABMGenUSERModal As ABMModalSheet = page.ModalSheet("USER")
	ActiveUSERUserID = 0

	Dim NewDate As Long = DateTime.Now 'ignore
	Dim ABMGenUSERUserName As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserName")
	Dim ABMGenUSERUserLogin As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserLogin")
	Dim ABMGenUSERUserPassword As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserPassword")
	Dim ABMGenUSERUserType As ABMCombo = ABMGenUSERModal.Content.Component("ABMGenUSERUserType")
	Dim ABMGenUSERUserActive As ABMCheckbox = ABMGenUSERModal.Content.Component("ABMGenUSERUserActive")
'	Dim ABMGenUSERpic As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERpic")

	ABMGenUSERUserName.Text = ""
	ABMGenUSERUserLogin.Text = ""
	ABMGenUSERUserPassword.Text = ""
	ABMGenUSERUserType.SetActiveItemId("0")
	ABMGenUSERUserActive.State = True
'	ABMGenUSERpic.Text = ""
	IsNewUSER=True
	page.ShowModalSheet("USER")
End Sub

' method you can call when the user wants to edit an existing record
Sub ABMGenUSEREdit(openId As Int)
	Dim ABMGenUSERModal As ABMModalSheet = page.ModalSheet("USER")
	ActiveUSERUserID = openId
	Dim NewDate As Long = DateTime.Now 'ignore
	Dim SQL As SQL = DBM.GetSQL
	Dim SQL_str As String = "SELECT UserID, UserName, UserLogin, UserPassword, UserType, UserActive, pic FROM users WHERE UserID = ? "
	Dim results As List = DBM.ABMGenSQLSelect(SQL, SQL_str, Array As Int(ActiveUSERUserID))
	If results.Size>0 Then
		Dim m As Map = results.Get(0)
		Dim ABMGenUSERUserName As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserName")
		Dim ABMGenUSERUserLogin As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserLogin")
		Dim ABMGenUSERUserPassword As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserPassword")
		Dim ABMGenUSERUserType As ABMCombo = ABMGenUSERModal.Content.Component("ABMGenUSERUserType")
		Dim ABMGenUSERUserActive As ABMCheckbox = ABMGenUSERModal.Content.Component("ABMGenUSERUserActive")
'		Dim ABMGenUSERpic As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERpic")

		If m.GetDefault("username", Null) = Null Then
			ABMGenUSERUserName.Text = ""
		Else
			ABMGenUSERUserName.Text = m.Get("username")
		End If

		If m.GetDefault("userlogin", Null) = Null Then
			ABMGenUSERUserLogin.Text = ""
		Else
			ABMGenUSERUserLogin.Text = m.Get("userlogin")
		End If

		If m.GetDefault("userpassword", Null) = Null Then
			ABMGenUSERUserPassword.Text = ""
		Else
			ABMGenUSERUserPassword.Text = m.Get("userpassword")
		End If
		
		If m.GetDefault("usertype", Null) = Null Then
			ABMGenUSERUserType.SetActiveItemId("0")
		Else
			ABMGenUSERUserType.SetActiveItemId(""&m.Get("usertype") )
		End If

		If m.GetDefault("useractive", Null) = Null Then
			ABMGenUSERUserActive.State = True
		Else
			ABMGenUSERUserActive.State = m.Get("useractive") = "1"
		End If

'		If m.GetDefault("pic", Null) = Null Then
'			ABMGenUSERpic.Text = ""
'		Else
'		'	ABMGenUSERpic.Text = m.Get("pic")
'		End If

		IsNewUSER=False
		page.ShowModalSheet("USER")
	Else
		Log("No record found")
	End If
	DBM.CloseSQL(SQL)
End Sub

' the user clicked save the form
Sub ABMGenUSERSave_Clicked(Target As String)
	Dim ABMGenUSERModal As ABMModalSheet = page.ModalSheet("USER")
	Dim Variables As List
	Variables.Initialize
	Dim NewDate As Long = DateTime.Now 'ignore

	Dim SQL As SQL = DBM.GetSQL
	Dim valueDouble As Double 'ignore
	Dim valueString As String 'ignore
	Dim valueInt As Int 'ignore
	Dim valueBoolean As Boolean 'ignore
	Dim valueLong As Long 'ignore
	Dim ret As Int 'ignore

	If IsNewUSER = False Then ' check if still exists
		Dim SQL_chk As String = "SELECT UserID FROM users WHERE UserID = ? "
		IsNewUSER = (DBM.ABMGenSQLSelectSingleResult(SQL, SQL_chk, Array As Int(ActiveUSERUserID))<=DBM.DBOK)
	End If

	If IsNewUSER Then
		Dim ABMGenUSERUserName As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserName")
		Dim ABMGenUSERUserLogin As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserLogin")
		Dim ABMGenUSERUserPassword As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserPassword")
		Dim ABMGenUSERUserType As ABMCombo = ABMGenUSERModal.Content.Component("ABMGenUSERUserType")
		Dim ABMGenUSERUserActive As ABMCheckbox = ABMGenUSERModal.Content.Component("ABMGenUSERUserActive")
'		Dim ABMGenUSERpic As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERpic")

		valueString = ABMGenUSERUserName.Text
		If ABMGenNotEmpty(valueString) = False Then
			
			page.Msgbox("ERR","Required field...","Enter a Valid User Name","OK",False,ABM.MSGBOX_POS_BOTTOM_CENTER,"")
			'  this is an error in genbuilder - should be -> ABMGenBuildUSERBadInput   NOT -> ABMGenUSERBadInput
'			Dim ABMGenUSERBadInputMessage As ABMLabel = ABMGenUSERBadInput.Content.Component("ABMGenUSERBadInputMessage")
			
'			Dim ABMGenUSERBadInputMessage As ABMLabel = ABMGenBuildUSERBadInput.Content.Component("ABMGenUSERBadInputMessage")
'			ABMGenUSERBadInputMessage.Text="Please enter all fields first!: User Name"
'			page.ShowModalSheet("USERBadInput")
			Return
		End If
		Variables.Add(valueString)

		valueString = ABMGenUSERUserLogin.Text
		If ABMGenNotEmpty(valueString) = False Then
			page.Msgbox("ERR","Required field...","Enter a Valid User Login","OK",False,ABM.MSGBOX_POS_BOTTOM_CENTER,"")
			
'			Dim ABMGenUSERBadInputMessage As ABMLabel = ABMGenBuildUSERBadInput.Content.Component("ABMGenUSERBadInputMessage")
'			ABMGenUSERBadInputMessage.Text="Please enter all fields first!: Login Name"
'			page.ShowModalSheet("USERBadInput")
			Return
		End If
		Variables.Add(valueString)

		valueString = ABMGenUSERUserPassword.Text
		Variables.Add(valueString)

		valueString = ABMGenUSERUserType.GetActiveItemId
		Variables.Add(valueString)

		valueBoolean = ABMGenUSERUserActive.State
		Variables.Add(valueBoolean)

		valueString = ""
		Variables.Add(valueString)

		ret = DBM.ABMGenSQLInsert(SQL, "INSERT INTO users(UserName, UserLogin, UserPassword, UserType, UserActive, pic) VALUES(?, ?, ?, ?, ?, ?)", Variables)
	Else
		Dim ABMGenUSERUserName As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserName")
		Dim ABMGenUSERUserLogin As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserLogin")
		Dim ABMGenUSERUserPassword As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERUserPassword")
		Dim ABMGenUSERUserType As ABMCombo = ABMGenUSERModal.Content.Component("ABMGenUSERUserType")
		Dim ABMGenUSERUserActive As ABMCheckbox = ABMGenUSERModal.Content.Component("ABMGenUSERUserActive")
'		Dim ABMGenUSERpic As ABMInput = ABMGenUSERModal.Content.Component("ABMGenUSERpic")

		valueString = ABMGenUSERUserName.Text
		If ABMGenNotEmpty(valueString) = False Then
			page.Msgbox("ERR","Required field...","Enter a Valid User Name","OK",False,ABM.MSGBOX_POS_BOTTOM_CENTER,"")

			'  ABMGenBuildUSERBadInput
'			Dim ABMGenUSERBadInputMessage As ABMLabel = ABMGenUSERBadInput.Content.Component("ABMGenUSERBadInputMessage")
'			Dim ABMGenUSERBadInputMessage As ABMLabel = ABMGenBuildUSERBadInput.Content.Component("ABMGenUSERBadInputMessage")
			
			
'			ABMGenUSERBadInputMessage.Text="Please enter all fields first!: User Name"
'			page.ShowModalSheet("USERBadInput")
			Return
		End If
		Variables.Add(valueString)

		valueString = ABMGenUSERUserLogin.Text
		If ABMGenNotEmpty(valueString) = False Then
			page.Msgbox("ERR","Required field...","Enter a Valid User Login","OK",False,ABM.MSGBOX_POS_BOTTOM_CENTER,"")
			
'			Dim ABMGenUSERBadInputMessage As ABMLabel = ABMGenBuildUSERBadInput.Content.Component("ABMGenUSERBadInputMessage")
'			ABMGenUSERBadInputMessage.Text="Please enter all fields first!: Login Name"
'			page.ShowModalSheet("USERBadInput")
			Return
		End If
		Variables.Add(valueString)

		valueString = ABMGenUSERUserPassword.Text
		Variables.Add(valueString)

		valueString = ABMGenUSERUserType.GetActiveItemId
		Variables.Add(valueString)

		valueBoolean = ABMGenUSERUserActive.State
		Variables.Add(valueBoolean)

		valueString = "" ' ABMGenUSERpic.Text - not needed
		Variables.Add(valueString)

		ret = DBM.ABMGenSQLUpdate(SQL, "UPDATE users SET UserName=?, UserLogin=?, UserPassword=?, UserType=?, UserActive=?, pic=? WHERE UserID=" & ActiveUSERUserID, Variables)
	End If
	DBM.CloseSQL(SQL)
	page.CloseModalSheet("USER")

	ActiveUSERUserID = 0

	Dim ABMGenPaginationUSER As ABMPagination = page.Component("ABMGenPaginationUSER")
	LoadABMGenTableUSER(ABMGenPaginationUSER.GetActivePage())
End Sub

' the user clicked on cancel on the save form
Sub ABMGenUSERCancel_Clicked(Target As String)
	ActiveUSERUserID = 0
	page.CloseModalSheet("USER")
End Sub

' method to check if a certain field is valid
Sub ABMGenNotEmpty(value As String) As Boolean
	' TODO by the programmer!
	If value.Length < 2 Then
		Return False
	Else
		Return True
	End If
End Sub

Sub ABMGenBuildUSERDelete() As ABMModalSheet
	Dim ABMGenUSERDeleteModal As ABMModalSheet
	ABMGenUSERDeleteModal.Initialize(page, "USERDelete", False, False, "")
	ABMGenUSERDeleteModal.IsDismissible = False

	' Build the content grid
	ABMGenUSERDeleteModal.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
	ABMGenUSERDeleteModal.Content.BuildGrid  'IMPORTANT once you loaded the complete grid AND before you start adding components

	' add message label
	Dim ABMGenUSERDeleteMessage As ABMLabel
	ABMGenUSERDeleteMessage.Initialize(page, "ABMGenUSERDeleteMessage", "Are you sure you want to delete this user?" , ABM.SIZE_PARAGRAPH, False, "")
	ABMGenUSERDeleteModal.Content.CellR(0,1).AddComponent(ABMGenUSERDeleteMessage)

	' Build the footer grid
	ABMGenUSERDeleteModal.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,6,6,6,3,3,3,"").AddCellsOS(1,0,0,0,3,3,3, "")
	ABMGenUSERDeleteModal.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components

	' create the buttons for the footer
	Dim ABMGenUSERDeleteYes As ABMButton
	ABMGenUSERDeleteYes.InitializeFlat(page, "ABMGenUSERDeleteYes", "", "", "Yes", "transparent")
	ABMGenUSERDeleteModal.Footer.Cell(1,1).AddComponent(ABMGenUSERDeleteYes)

	Dim ABMGenUSERDeleteNo As ABMButton
	ABMGenUSERDeleteNo.InitializeFlat(page, "ABMGenUSERDeleteNo", "", "", "No", "transparent")
	ABMGenUSERDeleteModal.Footer.Cell(1,2).AddComponent(ABMGenUSERDeleteNo)

	Return ABMGenUSERDeleteModal
End Sub

' method you can call when the user wants to delete a record
Sub ABMGenUSERDelete(deleteId As Int)
	ActiveUSERUserID = deleteId
	page.ShowModalSheet("USERDelete")
End Sub

' the user clicked yes on the delete messagebox
Sub ABMGenUSERDeleteYes_Clicked(Target As String)
	Dim SQL As SQL = DBM.GetSQL
	DBM.ABMGenSQLDelete(SQL, "DELETE FROM users WHERE UserID = ? ", Array As Int(ActiveUSERUserID))
	DBM.CloseSQL(SQL)
	page.CloseModalSheet("USERDelete")
	ActiveUSERUserID = 0

	Dim ABMGenPaginationUSER As ABMPagination = page.Component("ABMGenPaginationUSER")
	LoadABMGenTableUSER(ABMGenPaginationUSER.GetActivePage())
End Sub

Sub ABMGenUSERDeleteNo_Clicked(Target As String)
	page.CloseModalSheet("USERDelete")
End Sub

Sub ABMGenBuildUSERBadInput() As ABMModalSheet
	Dim ABMGenUSERBadInputModal As ABMModalSheet
	ABMGenUSERBadInputModal.Initialize(page, "USERBadInput", False, False, "")
	ABMGenUSERBadInputModal.IsDismissible = False

	' Build the content grid
	ABMGenUSERBadInputModal.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
	ABMGenUSERBadInputModal.Content.BuildGrid  'IMPORTANT once you loaded the complete grid AND before you start adding components

	' add message label
	Dim ABMGenUSERBadInputMessage As ABMLabel
	ABMGenUSERBadInputMessage.Initialize(page, "ABMGenUSERBadInputMessage", "Please enter all fields first!" , ABM.SIZE_PARAGRAPH, False, "")
	ABMGenUSERBadInputModal.Content.CellR(0,1).AddComponent(ABMGenUSERBadInputMessage)

	' Build the footer grid
	ABMGenUSERBadInputModal.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,6,6,6,3,3,3,"").AddCellsOS(1,0,0,0,3,3,3, "")
	ABMGenUSERBadInputModal.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components

	' create the buttons for the footer
	Dim ABMGenUSERBadInputCancel As ABMButton
	ABMGenUSERBadInputCancel.InitializeFlat(page, "ABMGenUSERBadInputCancel", "", "", "Close", "transparent")
	ABMGenUSERBadInputModal.Footer.Cell(1,2).AddComponent(ABMGenUSERBadInputCancel)

	Return ABMGenUSERBadInputModal
End Sub

' the user clicked ok on the Bad Input messagebox
Sub ABMGenUSERBadInputCancel_Clicked(Target As String)
	page.CloseModalSheet("USERBadInput")
End Sub

Sub ABMGenBuildUSERComboItem(id As String, title As String) As ABMLabel 'ignore
	Dim ABMGenLabel As ABMLabel
	ABMGenLabel.Initialize(page, id, "{NBSP}" & title, ABM.SIZE_H6, True, "")
	ABMGenLabel.VerticalAlign = True
	Return ABMGenLabel
End Sub
#End Region



#Region BuildCrudCode

Sub BuildCrudCode  ' used to generate code

	'users table structure used in this example
	'
	'Column			Type
	'---------------------------
	'UserID			int(11)
	'UserName		varchar(255)
	'UserLogin		varchar(255)
	'UserPassword	varchar(100)
	'UserType		int(11)
	'UserActive		int(11)
	'pic			mediumblob - to hold user image - not used per se

	Dim MyCrudDef As ABMGeneratorCRUDDefinition
	
	Log(" Running BuildCrudCode ")
	' see the help popup for the Initialize method - it explains all...
	MyCrudDef.Initialize (  "UserID",  "users", "Enter all fields for this user", "Save", "Cancel",  "Yes", "No", "Close", "Are you sure you want to delete this user?", "Please enter all fields first!")
	MyCrudDef.IgnoreAutoNumberInINSERT = True     ' do not include the IDfieldname in inserts - generally these are AutoInc fields
	
	' Overview methods are for the ABMtable creation
	MyCrudDef.OverviewSetTheme("tbltheme")        ' the theme to use for the table
	MyCrudDef.OverviewHasEdit("Open/Edit")        ' include a open / edit button on each row
	MyCrudDef.OverviewHasDelete("Delete")         ' include a delete button on each row
	MyCrudDef.OverviewHasPagination(5)            ' number of rows to fetch for each pagination
	MyCrudDef.OverviewHasSearchBox("Search user") ' title for search box
	MyCrudDef.OverviewFooter("Number of rows")    ' footer title
	MyCrudDef.OverviewHasAddButton                ' cerate a "Add" button 
	
	' define the fieldnames that will be used from our DB table
	MyCrudDef.Set01FieldNames(   Array As String ("UserID"  , "UserName"  , "UserLogin"   , "UserPassword"  , "UserType"  , "UserActive"  , "pic"   ))
		
	' (Required)
	' This section defines where rows and cells will be placed.
	' "" implies it will be hidden.
	' "1:0:4"  1 means place on row 1.  0 means offest on S,M,L devices.   4 means make this cell 4 cols wide.
	' all cell widths for each row must up to 12...
	' you notice this same structure is repeated for row 2 ("2:0:4"  , "2:0:4"   , "2:0:4") / row 2, 0 offset, 4 cols wide each...
	' same for row 3 - but row 4 is one cell - 12 wide....
	MyCrudDef.Set02RowOffsetSizes(   Array As String ( ""   , "1:0:4"   , "1:0:4"   , "1:0:4"  , "2:0:4"   , "2:0:4"  , "2:0:4"  ))
	
	' these are our label titles for each table column and sheet cell component. 
	' We also add two additional labels for the edit and delete buttons added to each row
	MyCrudDef.Set03LabelTexts(       Array As String (""   , "User Name"    , "Login Name"     , "Password"      , "User Type"  , "Active"  , "Picture" ))
	
	' (Required)
	' this section defines the TYPE of ABM component that will be placed into each cell.  Currently, there are 15 possible choices.  Try ABM.Gen...  to see your options.
	MyCrudDef.Set04ComponentTypes(   Array As Int (ABM.GEN_NONE   , ABM.GEN_TEXT  , ABM.GEN_TEXT  , ABM.GEN_TEXT  , ABM.GEN_TEXT   , ABM.GEN_CHECKBOX   , ABM.GEN_TEXT  )) 
	
	' (Required)
	' this section defines our "default values" when ADDING (Inserting) a new item using the modal sheet.  When "editing", the values are sourced from the selected record.
	' notice boolean type components (Switch in this case) use "true" or "false"
	MyCrudDef.Set05DefaultValues(    Array As String ( ""   , ""  , ""   , ""   , "0"  , "true" , ""  ))
	
	' (Not Required)
	'  this section will build methods used to populate combos for each ABMCombo component used - if desired.
	'  uses the statement - 	( Dim cmbZones As String = "SELECT pk, name from picklists where grp = 1" ) - shown above...
	'  not used in this example
	' MyCrudDef.Set06ComboQueries(     Array As String (""               , ""               , ""              , ""               , cmbZones              , ""                , ""                 , ""              , ""                  , ""                , ""           ))


	' (Not Required)
	' this section defines validation methods that will be injected into each component when saving (insert or update)
	' NotEmpty is the names of the method generated and used...  Shown are the examples...
	'
	'	' method to check if a certain field is valid - Not Empty!!!!
	'	Sub ABMGenNotEmpty(value As String) As Boolean
	'		' TODO by the programmer!
	'		Return True   - returns true as NOT to fail validation.....
	'	End Sub
	'
	MyCrudDef.Set08ValidationMethods(Array As String (""   , "NotEmpty" , "NotEmpty"  , ""  , "", "", ""   ))


	' there may be certain fields that are NOT used in the query update process. 
	' In this example, "UserID" is our primary key and an AutoIncrement field in MySQL table, so don't touch it!!!!
	'
	MyCrudDef.Set10UseInUpdates(            Array As Boolean(False            , True             , True            , True             , True                  , True              , True    ))
	MyCrudDef.Set11OverviewVisible(         Array As Boolean(False            , True             , True            , True             , True                  , True              , True   ))
	MyCrudDef.Set12OverviewHeaderThemes(    Array As String (""               , ""               , ""              , ""               , ""              , ""                , ""          ))
	MyCrudDef.Set13OverviewCellThemes(      Array As String (""               , ""               , ""              , ""               , ""              , ""                , ""            ))
	MyCrudDef.Set14OverviewIncludeInSearch( Array As Boolean(False            , True             , True            , True             , True                  , True              , True    ))
	MyCrudDef.Set15OverviewSortable(        Array As Boolean(False            , True             , True            , True             , True                  , True              , True    ))
	MyCrudDef.Set16OverviewHeaderHeights(   Array As Int    (0     ,0     , 0   , 0  , 0      , 0    , 0   ))
	MyCrudDef.Set17OverviewColumnWidths(    Array As Int    (0     ,0     , 0   , 0  , 0      , 0    , 0   ))
	
	' OK, with everything defined, generate the output code please!
	'
	' Generate the text files based on configuration above....
	'
	' NOTE: a DBM.txt file is also generated for your SQL methods....
	'
	' params (where to put generated file, file and sheet name, definition (MyCrudDef), default sheet size)
	gen.GenerateCRUDSheet(File.DirApp, "USER",   MyCrudDef,  ABM.MODALSHEET_SIZE_LARGE)
	genname = "USR.txt"  ' ignore... used below for example...
	
	Dim str As String = File.GetUri(File.DirApp,genname)
	page.Msgbox("msg"," This file may be found at: "&CRLF &str ,"File: '"&genname&"' Was Created!"&CRLF&"Use Show Button to Load in ABMCodeLabel"  ,"OK",False,ABM.MSGBOX_POS_BOTTOM_CENTER,"")
	
End Sub

#End Region


public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)

	theme.AddButtonTheme("btnred")
	theme.Button("btnred").BackColor = ABM.COLOR_RED

	theme.AddButtonTheme("btngreen")
	theme.Button("btngreen").BackColor = ABM.COLOR_TEAL


	theme.AddInputTheme("inputauto")
	theme.Input("inputauto").AutoCompleteZDepth = ABM.ZDEPTH_1
	
	theme.AddTableTheme("tbltheme")
	theme.Table("tbltheme").ZDepth = ABM.ZDEPTH_1
	
	theme.Table("tbltheme").AddCellTheme("bg")
	theme.Table("tbltheme").Cell("bg").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bg").ForeColor = ABM.COLOR_WHITE
	theme.Table("tbltheme").Cell("bg").Align = ABM.TABLECELL_HORIZONTALALIGN_LEFT
	
	theme.Table("tbltheme").AddCellTheme("bgr")
	theme.Table("tbltheme").Cell("bgr").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bgr").ForeColor = ABM.COLOR_WHITE
	theme.Table("tbltheme").Cell("bgr").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbltheme").AddCellTheme("bgc")
	theme.Table("tbltheme").Cell("bgc").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bgc").BackColorIntensity = ABM.INTENSITY_LIGHTEN1

	theme.Table("tbltheme").Cell("bgc").ForeColor = ABM.COLOR_YELLOW
	theme.Table("tbltheme").Cell("bgc").Align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	theme.Table("tbltheme").Cell("bgc").BorderWidth = 2
	theme.Table("tbltheme").Cell("bgc").BorderColor = ABM.COLOR_BLACK

	theme.Table("tbltheme").AddCellTheme("bgb")
	theme.Table("tbltheme").Cell("bgb").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bgb").BackColorIntensity = ABM.INTENSITY_LIGHTEN1

	theme.Table("tbltheme").Cell("bgb").ForeColor = ABM.COLOR_AMBER
	theme.Table("tbltheme").Cell("bgb").Align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	theme.Table("tbltheme").Cell("bgb").BorderWidth = 2
	theme.Table("tbltheme").Cell("bgb").BorderColor = ABM.COLOR_BLACK


	theme.Table("tbltheme").AddCellTheme("nocolor")
	theme.Table("tbltheme").Cell("nocolor").ActiveBackColor = ABM.COLOR_LIGHTGREEN
	theme.Table("tbltheme").Cell("nocolor").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN2
	theme.Table("tbltheme").Cell("nocolor").Align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
'	theme.Table("tbltheme").Cell("nocolor").FontSize = 35
'	theme.Table("tbltheme").Cell("nocolor").Align = ABM.TABLECELL_VERTICALALIGN_TOP
	


	theme.Table("tbltheme").AddCellTheme("positive")
	theme.Table("tbltheme").Cell("positive").BackColor = ABM.COLOR_GREEN
	theme.Table("tbltheme").Cell("positive").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbltheme").Cell("positive").ActiveBackColor = ABM.COLOR_GREEN
	theme.Table("tbltheme").Cell("positive").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN1
	'theme.Table("tbltheme").Cell("positive").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbltheme").AddCellTheme("negative")
	theme.Table("tbltheme").Cell("negative").BackColor = ABM.COLOR_RED
	theme.Table("tbltheme").Cell("negative").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbltheme").Cell("negative").ActiveBackColor = ABM.COLOR_RED
	theme.Table("tbltheme").Cell("negative").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN1
	'theme.Table("tbltheme").Cell("negative").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbltheme").AddCellTheme("points")
	theme.Table("tbltheme").Cell("points").ActiveBackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("points").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN2
	theme.Table("tbltheme").Cell("points").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbltheme").AddCellTheme("openedit")
	theme.Table("tbltheme").Cell("openedit").ActiveBackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("openedit").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN2
	theme.Table("tbltheme").Cell("openedit").Align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	
	
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	' saving the navigation bar position
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If

	ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub


#Region other_methods_generated

Sub Page_Dropped(Params As Map)
	If Params.Get("before") = "" Then
		Log("'" & Params.Get("component") & "' moved from " & Params.Get("source") & " to " & Params.Get("target"))
	Else
		Log("'" & Params.Get("component") & "' moved from " & Params.Get("source") & " to " & Params.Get("target") & " before component " & Params.Get("before"))
	End If
End Sub

Sub Page_InputboxResult(returnName As String, result As String)
	
End Sub


Sub Page_DebugConsole(message As String)
	Log("---> " & message)
End Sub

Sub Page_FileUploaded(FileName As String, success As Boolean)
	
End Sub

Sub Page_ToastClicked(toastID As String, Action As String)
		
End Sub

Sub Page_ToastDismissed(ToastId As String)
	
End Sub

Sub Page_Authenticated(Params As Map)
	
End Sub

Sub Page_FirebaseAuthError(extra As String)
	
End Sub

Sub Page_FirebaseAuthStateChanged(IsLoggedIn As Boolean)
	
End Sub

Sub Page_FirebaseStorageError(jobID As String, extra As String)
	
End Sub

Sub Page_FirebaseStorageResult(jobID As String, extra As String)
	
End Sub

Sub Page_ModalSheetDismissed(ModalSheetName As String)
	
End Sub

Sub Page_NextContent(TriggerComponent As String)
	
End Sub

Sub Page_SignedOffSocialNetwork(Network As String, Extra As String)
	
End Sub

Sub page_CellClicked(Target As String, RowCell As String)
	
End Sub

Sub page_RowClicked(Target As String, Row As String)
	
End Sub

Sub Page_NativeResponse(jsonMessage As String)
	
End Sub

Sub Page_NavigationbarSearch(search As String)
	
End Sub

#End Region

